#ifndef _HANDRECOGNITION_H_
#define _HANDRECOGNITION_H_

#include "rsp.h"


#define HR_MAX_HIST 32

#define min( a, b ) ( ((a)<(b))?(a):(b) )

class HandRecognition {

  CvNormalBayesClassifier classifier;
  RSPtype hist[HR_MAX_HIST];
  int hist_len, hist_pos;

public:
  HandRecognition(int _hist_len=6);
  ~HandRecognition(void);

  bool train(const char *fn);
  RSPtype classify(IplImage *input);
  RSPtype history(RSPtype choose, float *prob=NULL);
};

const char *handType(RSPtype what);

void HuMoments(IplImage *input, CvMoments *moments, CvHuMoments *hu_moments);
int computeHuMoments(char *srcDir, char *outPath);
int classifyDir(char *srcDir, char *outPath, char *trainset);

#endif // _HANDRECOGNITION_H_

