#ifndef H_RECOGNIZER
#define H_RECOGNIZER

#include <cv.h>


enum {
    UNKNOWN = 0,
    PAPER,
    SCISSORS,
    ROCK
};

class Recognizer {
    public:
    Recognizer();
    void cutHand(IplImage *src);
    int recognizeHandSignal(IplImage* src);
    
    private:
    
    unsigned long getAera(IplImage* src);    
    unsigned long getBoundary(IplImage* src);
    
    void getShapeStat(IplImage* src, unsigned long* stat);
        
    void contour(IplImage* src, IplImage* dest);
    void getBoundingBox(IplImage* src, int& x1, int& y1, int& x2, int& y2);
    void getDistanceMap(IplImage* src, unsigned int* dm);
    void drawDistanceMap(unsigned int* dm, IplImage* dest);
};




#endif
